# Item booking


**Item booking is a flexible document for registering timeslots booking for an Item.**

### Usage

You can use the Item Booking document type in two ways:
1. You can make a new booking manually through the desk.
2. You can configure the Item Booking document to allow your website users to book a slot themselves.


### Prerequisites

#### Stock settings

If you want to allow guests to select an available slot on your website, you need to configure a unit of measure corresponding to one minute in the "Item Booking" section of the stock settings:
All slots being multiples of 1 minute, it is necessary to define it for dokos.

#### Unit of measure

In order for the system to be able to convert the sales unit of measure into minutes to calculate the slots available, you need to configure one or several unit of measure conversion factors.

In the document type UOM conversion factor, check that you have a conversion factor for all your sales and stock UOM for one minute:
|From     |To    |Value           |
|---------|------|----------------|
|Sales UOM|Minute|Minute/Sales UOM|

![Time conversion to minutes](/images/stocks/item_booking/time_conversion.png)

:::tip Example
If you plan to sell hourly and daily slots, make sure you have at least these two conversion factors:

|From|To    |Value|
|----|------|-----|
|Hour|Minute|60   |
|Day |Minute|480  |

Please note that here, 1 day corresponds to 480 minutes because we consider that, from a sales perspective, we sell 8 hour days.
You can, of course, adjust this value according to your business needs.

:::

#### Item Booking Calendar

You can configure as many calendars as necessary per items and units of measure.
The calendar selection rule for an item booking is as follow:

1. dokos looks for a calendar linked with the item and the unit of measure requested
2. dokos looks for a calendar linked with the requested item, without linked unit of measure
3. dokos looks for a calendar linked to the requested unit of measure, without linked item
4. dokos looks for a calendar that is linked neither to item nor the requested unit of measure

It is therefore useful to configure at least one calendar, not linked to any item nor unit of measure, that will be considered the default calendar.

#### Item

In order to allow the booking of timeslots on your website, you need to first show this item on your website: in the __Website__ section, select __Show in Website__.  
Enabling this option will allow you to also __Enable Item Booking__.

Once enabled, your website users will be given a choice between buying units or selecting a slot:
![Item booking options in website](/images/stocks/item_booking/item_website_options.png)

You can uncheck the field __Disabled unit purchasing__ to allow only the booking of timeslots.

If you want to autorize bookings with different unit of measure (day, hour,...), add them in the unit of measure table.
Please note that the conversion for bookings will be done against conversion factors for one minute, as setup above.

### Slot booking

Your website users will be presented with a popup listing all available slots.
They can click on an available slot to add it to their shopping cart.


![Booking dialog](/images/stocks/item_booking/item_booking_dialog.png)


Draft bookings are automatically deleted every 15 minutes in case user abandon their shopping cart.